/****************************************************************************\
*   DIG_CONV - this source file is part of Binary vIEW project (BIEW)        *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   addons/tools/dig_conv.c                            *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain implementation of digital convertor.                    *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include <string.h>
#include <stdlib.h>
#include "bconsole.h"
#include "biewutil.h"
#include "reg_form.h"
#include "__os_dep.h"
#include "_sys_dep.h"
#include "kbd_code.h"

static int __NEAR__ GetFullBin(unsigned long value,char * buff)
{
 char byte,*b,started = 0;
 buff[0] = 0;
 byte = (value >> 28) & 0x0F;
 if(byte) { b = GetBinary(byte); strcat(buff,&b[4]); started = 1; }
 byte = (value >> 24) & 0x0F;
 if(byte || started) { b = GetBinary(byte); strcat(buff,&b[4]); started = 1; }
 byte = (value >> 20) & 0x0F;
 if(byte || started) { b = GetBinary(byte); strcat(buff,&b[4]); started = 1; }
 byte = (value >> 16) & 0x0F;
 if(byte || started) { b = GetBinary(byte); strcat(buff,&b[4]); started = 1; }
 byte = (value >> 12) & 0x0F;
 if(byte || started) { b = GetBinary(byte); strcat(buff,&b[4]); started = 1; }
 byte = (value >> 8) & 0x0F;
 if(byte || started) { b = GetBinary(byte); strcat(buff,&b[4]); started = 1; }
 byte = (value >> 4) & 0x0F;
 if(byte || started) { b = GetBinary(byte); strcat(buff,&b[4]); }
 byte = value & 0x0F;
 b = GetBinary(byte); strcat(buff,&b[4]);
 return strlen(buff);
}

static int __NEAR__ Dig2Str(unsigned long value,char * buff,int action)
{
 if(action == 0) return strlen(ultoa(value,buff,16));
 if(action == 1) return strlen(ltoa(value,buff,8));
 if(action == 2) return strlen(ultoa(value,buff,10));
 if(action == 3) return strlen(ltoa(value,buff,10));
 if(action == 4) return GetFullBin(value,buff);
 if(action == 5) return strlen(ultoa(value,buff,2));
 return 0;
}

static unsigned long __NEAR__ Str2Dig(char * buff,int action)
{
 if(action == 0) return strtoul(buff,NULL,16);
 if(action == 1) return strtoul(buff,NULL,8);
 if(action == 2) return strtoul(buff,NULL,10);
 if(action == 3) return strtol(buff,NULL,10);
 if(action == 4) return strtoul(buff,NULL,2);
 return 0;
}

char bleg[] = "01",olec[] = "01234567";
extern char decleg[];

static void __NEAR__ DCStaticPaint(TWindow * wdlg,char * wbuff,long digit)
{
 int rlen,i;
 TWindow * using = twUsedWin();
    twUseWin(wdlg);
    rlen = Dig2Str(digit,wbuff,0);
    twGotoXY(3,4); twPutS(wbuff); for(i = rlen;i < 8;i++)  twPutChar(''); twPutS("   [Hex]");
    rlen = Dig2Str(digit,wbuff,1);
    twGotoXY(29,4); twPutS(wbuff); for(i = rlen;i < 11;i++)  twPutChar(''); twPutS(" [Oct]");
    rlen = Dig2Str(digit,wbuff,2);
    twGotoXY(3,6); twPutS(wbuff); for(i = rlen;i < 10;i++)  twPutChar(''); twPutS(" [Dec]");
    rlen = Dig2Str(digit,wbuff,3);
    twGotoXY(29,6); twPutS(wbuff); for(i = rlen;i < 11;i++) twPutChar(''); twPutS(" [+-Dec]");
    rlen = Dig2Str(digit,wbuff,4);
    twGotoXY(5,8); twPutS(wbuff); for(i = rlen;i < 32;i++)  twPutChar(''); twPutS(" [Bin]");
    twUseWin(using);
}

void DigConv( void )
{
 int X1,Y1,X2,Y2,XX1,XX2,YY1,YY2;
 TWindow * wdlg = CrtHlpWndnls(" Digital convertor ",48,9);
 TWindow * ewnd[5];
 int i,active,oactive,lastbyte,rlen,stx = 0;
 char wbuff[34],redraw,attr;
 char * legal[5] = { &legalchars[2], olec, &decleg[2], decleg, bleg };
 int mlen[5] = { 8, 11, 10, 11, 32 };
 unsigned long digit;
 twGetWinPos(wdlg,&X1,&Y1,&X2,&Y2);
 XX1 = X1 + 3;
 YY1 = Y1 + 4;
 XX2 = XX1 + 7;
 YY2 = YY1;
 ewnd[0] = WindowOpen(XX1,YY1,XX2,YY2,TWS_CURSORABLE | TWS_NLS866);
 twSetColor(White,Cyan); twClearWin();
 XX1 = X1 + 29;
 XX2 = XX1 + 10;
 ewnd[1] = WindowOpen(XX1,YY1,XX2,YY2,TWS_CURSORABLE | TWS_NLS866);
 twSetColor(White,Cyan); twClearWin();
 XX1 = X1 + 3;
 YY1 = Y1 + 6;
 XX2 = XX1 + 9;
 YY2 = YY1;
 ewnd[2] = WindowOpen(XX1,YY1,XX2,YY2,TWS_CURSORABLE | TWS_NLS866);
 twSetColor(White,Cyan); twClearWin();
 XX1 = X1 + 29;
 XX2 = XX1 + 10;
 ewnd[3] = WindowOpen(XX1,YY1,XX2,YY2,TWS_CURSORABLE | TWS_NLS866);
 twSetColor(White,Cyan); twClearWin();
 XX1 = X1 + 5;
 YY1 = Y1 + 8;
 XX2 = XX1 + 31;
 YY2 = YY1;
 ewnd[4] = WindowOpen(XX1,YY1,XX2,YY2,TWS_CURSORABLE | TWS_NLS866);
 twSetColor(White,Cyan); twClearWin();
 twUseWin(wdlg);
 digit = 0;
 twGotoXY(3,2); twPutS("Convert digits between bases [16, 10, 8, 2]");
 DCStaticPaint(wdlg,wbuff,digit);
 oactive = 1;
 active =
 wbuff[0] = 0;
 digit = 0;
 attr = __ESS_NOTUPDATELEN | __ESS_WANTRETURN | __ESS_ENABLEINSERT;
 while(1)
 {
   if(active != oactive)
   {
     twHideWin(ewnd[oactive]);
     twShowWin(ewnd[active]);
     twUseWin(ewnd[active]);
     oactive = active;
     stx = 0;
   }
   rlen = Dig2Str(digit,wbuff,active == 4 ? 5 : active);
   if(stx > rlen) stx = rlen;
   NextCh:
   lastbyte = eeditstring(wbuff,legal[active],&mlen[active],1,&stx,attr,
                          NULL,rlen,0);
   if((char)lastbyte == '-' || (char)lastbyte == '+') goto NextCh;
   if(lastbyte == KE_ESCAPE) break;
   digit = Str2Dig(wbuff,active);
   redraw = 0;
   switch(lastbyte)
   {
     case KE_TAB        : active++; break;
     case KE_SHIFT_TAB  : active--; break;
     case KE_LEFTARROW  :
     case KE_RIGHTARROW : break;
     case KE_UPARROW    : active -= 2; break;
     case KE_DOWNARROW  : active += 2; break;
     default: redraw = 1; break;
   }
   if(active < 0) active = 4;
   if(active > 4) active = 0;
   if(redraw) DCStaticPaint(wdlg,wbuff,digit);
 }
 CloseWnd(wdlg);
 for(i = 0;i < 5;i++) CloseWnd(ewnd[i]);
}

REGISTRY_TOOL DigitalConvertor =
{
  "~Digital convertor",
  DigConv,
  NULL,
  NULL
};
