/****************************************************************************\
*   BCONSOLE - this header file is part of Binary vIEW project (BIEW)        *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   bconsole.h                                         *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file included BIEW console functions description.                    *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/

#ifndef __BCONSOLE__H
#define __BCONSOLE__H

#ifdef __cplusplus
extern "C" {
#endif

#ifndef __TWIN_H
#include "twin.h"
#endif

extern unsigned short Width,Height;
extern TWindow *MainWnd,*HelpWnd,*TitleWnd,*CritErrWnd;

extern void         initBConsole( unsigned long flg );
extern void         termBConsole( void );
extern int          IsKbdTerminate( void );

typedef void (* pagefunc)(TWindow *win,void **__obj,unsigned i__obj,unsigned total_obj);

#define FRAME_UP        0x00
#define FRAME_DOWN      0x01
#define FRAME_3DMASK    0x0F
#define FRAME_THIN      0x00
#define FRAME_MEDIUM    0x10
#define FRAME_THICK     0x20
#define FRAME_HEIGHTMASK 0xF0
extern void             CloseWnd(TWindow *w);
extern TWindow *        CreateWindowDD(char * title,int x2,int y2,char col,
                                       char back,char frcol,char frback);
extern TWindow *        CreateWindowDDnls(char * title,int x2,int y2,char col,
                                          char back,char frcol,char frback);
extern TWindow *        CrtHlpWnd(char *,int,int);
extern TWindow *        CrtHlpWndnls(char *,int,int);
extern TWindow *        WindowOpen(int x1,int y1,int x2,int y2,int flags);
extern void             DisplayBox(char * *names,unsigned nlist,char *title);
/* Edit string styles */
#define __ESS_ENABLEINSERT 0x0001
#define __ESS_HARDEDIT     0x0002
#define __ESS_WANTRETURN   0x0004
#define __ESS_ASHEX        0x0008
#define __ESS_NOTUPDATELEN 0x0010
#define __ESS_FILLER_7BIT  0x0020
extern int              editstring(char *s,char *legal,int maxlength);
extern int              eeditstring(char *s, char *legal, int *maxlength,
                                    int y,int *stx,int attr,char *undo,
                                    char ncol,char hcol);
extern int              xeditstring(char *s,char *legal,int maxlength);
extern void             ErrMessageBox(char * text,char * title);
extern void             errnoMessageBox(char *text,char *title,int __errno__);
extern void             ListBox(char * * names,unsigned nlist,char * title);
extern void             TMessageBox(char * text,char * title);
extern void             NotifyBox(char * text,char * title);
extern int              PageBox(int width,int height,void * * __obj,
                                unsigned nobj,pagefunc func);
extern void             MemOutBox(char *user_msg);
extern TWindow *        PleaseWaitWnd( void );
extern int              SearchDialog(char *serachbuff,unsigned char *searchlen,
                                     unsigned char *CaseSens,
                                     unsigned char *WordOnly,
                                     unsigned char *Backwarding);
extern int              Get2DigitDlg(char *title,char *text,unsigned char *xx);
extern int              Get8DigitDlg(char *title,char *text,char attr,
                                     unsigned long *xx);
extern int              GetStringDlg(char * buff,char * title,char *subtitle,
                                     char *prompt);

#define GJDLG_ABSOLUTE  0x00000000L
#define GJDLG_RELATIVE  0x00000001L
#define GJDLG_VIRTUAL   0x00000002L

extern int              GetJumpDlg( unsigned long * addr,unsigned long *flags);

#define FSDLG_BINMODE   0x00000000L
#define FSDLG_ASMMODE   0x00000001L
#define FSDLG_NOCOMMENT 0x00000000L
#define FSDLG_COMMENT   0x00000002L
#define FSDLG_STRUCTS   0x00000004L
#define FSDLG_NOMODES   0x00000000L
#define FSDLG_USEMODES  0x80000000L
extern int              GetFStoreDlg(char *title,char *fname,
                                     unsigned long *flags,
                                     unsigned long *start,
                                     unsigned long *end,
                                     char *prompt);
extern int              GetInsDelBlkDlg(char *title,unsigned long *start,
                                        long *size);

#define LB_SELECTIVE 0x01
#define LB_SORTABLE  0x02
#define LB_USEACC    0x04
extern int              CommonListBox(char **names,unsigned nlist,char *title,
                                      int acc,unsigned defsel);
extern int              SelBox(char ** names,unsigned nlist,char * title,
                               unsigned defsel);
extern int              SelBoxA(char ** names,unsigned nlist,char * title,
                                unsigned defsel);
extern int              SelListBox(char ** names,unsigned nlist,char * title,
                                   unsigned defsel);

extern void             ShowBox(char * text,char * title);

extern TWindow *        PercentWnd(char *text,char *title);

                           /* return !0 - if can continue
                                     0 -  if user want terminate process */
extern int              ShowPercentInWnd(TWindow *prcntwnd,unsigned n);

extern void             drawEmptyPrompt( void );
extern void             drawEditPrompt( void );
extern void             drawAsmEdPrompt( void );

extern int              GetEvent(void (*)(void),TWindow *);
extern void             PostEvent(int kbdcode);

#ifdef __cplusplus
}
#endif

#endif
