/****************************************************************************\
*   BIN_UTIL - this header file is part of Binary vIEW project (BIEW)        *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   bin_util.h                                         *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain prototypes of common functions of plugins\bin of BIEW   *
* project.                                                                   *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/

#ifndef __BIN_UTIL__H
#define __BIN_UTIL__H

#ifdef __cplusplus
extern "C" {
#endif

#ifndef __SYS_DEP_H
#include "_sys_dep.h"
#endif

#ifndef __BBIO_H
#include "bbio.h"
#endif

#ifndef __BIEWUTIL__H
#include "biewutil.h"
#endif

struct PubName
{
  unsigned long pa;
  unsigned long nameoff;
};

extern linearArray *PubNames;
extern unsigned fmtActiveState;

typedef void (*ReadPubName)(BGLOBAL b_cache,unsigned long nameoff,
                            char *buff,unsigned cb_buff);
typedef void (*ReadPubNameList)(BGLOBAL fmt_chahe,int interact);


extern void fmtSetState(int state);
extern int fmtComparePubNames(const void __HUGE__ *v1,const void __HUGE__ *v2);
extern int fmtFindPubName(BGLOBAL fmt_cache,char *buff,unsigned cb_buff,
                          unsigned long pa,
                          ReadPubNameList fmtReadPubNameList,
                          ReadPubName fmtReadPubName);
extern unsigned long fmtGetPubSym(BGLOBAL fmt_cache,char *str,unsigned cb_str,
                           unsigned *func_class,unsigned long pa,int as_prev,
                           ReadPubNameList fmtReadPubNameList,
                           ReadPubName fmtReadPubName);

typedef unsigned      (* GetNumItems)(BGLOBAL handle);
typedef int           (* ReadItems)(BGLOBAL handle,memArray * names,unsigned nnames);
typedef unsigned long (* CalcEntry)(unsigned,int dispmsg);
extern int               fmtShowList( GetNumItems gni,ReadItems ri,char * title,int flags,unsigned * ordinal);


#ifdef __cplusplus
}
#endif

#endif
 