/****************************************************************************\
*   BIEWLIB - this header file is part of Binary vIEW project (BIEW)         *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   lib/biewlib.h                                      *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain extensions of standard C library, that needed for BIEW  *
* project.                                                                   *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#ifndef __BIEWLIB_H
#define __BIEWLIB_H 1

#ifndef __SYS_DEP_H
#include "_sys_dep.h"
#endif

#ifndef __OS_DEP_H
#include "__os_dep.h"
#endif

#ifdef __cplusplus
extern "C" {
#endif

extern void  HQSort(void __HUGE__ *base, long num, unsigned width,
                    int (* compare)(const void __HUGE__ *e1, const void __HUGE__ *e2));
extern void __HUGE__ * HLFind(const void *key,void __HUGE__ *base,long nelem,unsigned width,
                    int (*compare)(const void __HUGE__ *e1,const void __HUGE__ *e2));

/* return nearest element of array toward zero */
extern unsigned long HLFindNearest(const void *key,void __HUGE__ *base,
                                   long nelem,unsigned width,
                                   int (*compare)(const void __HUGE__ *e1,
                                   const void __HUGE__ *e2));

extern int  isseparate(int ch);

extern void memupr(char *,unsigned);
extern void memlwr(char *,unsigned);

/*
  Only this function must be used for error reporting
	(do not use printf, fprintf, etc. !)
*/
extern int  printm(const char *str,...);


#ifdef __cplusplus
}
#endif

#endif 