/****************************************************************************\
*   TIMER - this source file is part of Binary vIEW project (BIEW)           *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   lib/sysdep/generic/posix/timer.c                   *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain implementation of timer depended part for POSIX.        *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include <sys/time.h>
#include <signal.h>
#include <stddef.h>
#include "__os_dep.h"

static timer_callback *user_func = NULL;
static struct itimerval otimer;
sig_t old_alrm = SIG_DFL;

static void my_alarm_handler( int signo )
{
  if(user_func) (*user_func)();
}

unsigned              __OsSetTimerCallBack(unsigned ms,timer_callback func)
{   
   struct itimerval itimer;
   unsigned ret;
   user_func = func;
   getitimer(ITIMER_REAL,&otimer);
   old_alrm = signal(SIGALRM,my_alarm_handler);
   signal(SIGALRM,my_alarm_handler);   
   itimer.it_interval.tv_sec = 0;
   itimer.it_interval.tv_usec = ms*1000;
   itimer.it_value.tv_sec = 0;
   itimer.it_value.tv_usec = ms*1000;
   setitimer(ITIMER_REAL,&itimer,NULL);
   getitimer(ITIMER_REAL,&itimer);
   ret = itimer.it_interval.tv_sec*1000 + itimer.it_interval.tv_usec/1000;
   if(!ret) __OsRestoreTimer();
   return ret;
}

                             /* Restore time callback function to original
                                state */
void                   __OsRestoreTimer(void)
{
  signal(SIGALRM,old_alrm);
  setitimer(ITIMER_REAL,&otimer,NULL);
}

 