/****************************************************************************\
*   MOUSE - this source file is part of Binary vIEW project (BIEW)           *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1999,2000 Konstantin Boldyshev                     *
*   License:              See below                                          *
*   Author and developer: Konstantin Boldyshev                               *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   lib/sysdep/generic/unix/mouse.c                    *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain implementation of nouse handles for UNIX clone OS.      *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include "__os_dep.h"
#include <stdio.h>
#include <string.h>

#ifdef HAVE_NCURSES
#include <curses.h>
#endif

#ifdef HAVE_MOUSE
extern int __unix_mou_x,__unix_mou_y,__unix_mou_btns;
extern void ReadNextEvent(void);
#else
#undef NCURSES_MOUSE_VERSION
#endif

int __MsGetState(void) { return 1; }
void __MsSetState(int ms_visible) { }

void __MsGetPos(unsigned *x, unsigned *y)
{
#ifdef HAVE_MOUSE
    ReadNextEvent();
    *x = __unix_mou_x;
    *y = __unix_mou_y;
#endif
}

int __MsGetBtns(void)
{
#ifdef HAVE_MOUSE
    int ret = 0;
    __unixReadNextEvent();
    if((__unix_mou_btns & BUTTON1_PRESSED) || 
      (__unix_mou_btns & BUTTON1_CLICKED))      ret |= MS_LEFTPRESS;
    if(__unix_mou_btns & BUTTON1_RELEASED)       ret &= ~MS_LEFTPRESS;
    if((__unix_mou_btns & BUTTON2_PRESSED) || 
      (__unix_mou_btns & BUTTON2_CLICKED))      ret |= MS_MIDDLEPRESS;
    if(__unix_mou_btns & BUTTON2_RELEASED)       ret &= ~MS_MIDDLEPRESS;
    if((__unix_mou_btns & BUTTON3_PRESSED) || 
      (__unix_mou_btns & BUTTON3_CLICKED))      ret |= MS_RIGHTPRESS;
    if(__unix_mou_btns & BUTTON3_RELEASED)       ret &= ~MS_RIGHTPRESS;

    return ret;
#endif
    return 0;
}

void __term_mouse( void )
{
}

int __init_mouse(void)
{
#ifdef HAVE_MOUSE
    mousemask(REPORT_MOUSE_POSITION | ALL_MOUSE_EVENTS, NULL);
#endif
    return 0;
}
