/****************************************************************************\
*   OS_DEP - this source file is part of Binary vIEW project (BIEW)          *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1999-2000 Konstantin Boldyshev                     *
*   License:              See below                                          *
*   Author and developer: Konstantin Boldyshev                               *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   lib/sysdep/generic/unix/os_dep.c                   *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
* This file contains implementation of unix compatible OS dependent part.    *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/

#include "__os_dep.h"
#include "_sys_dep.h"
#include "biewutil.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <signal.h>
#include <unistd.h>
#include <time.h>
#include <sys/types.h>
#include <sys/stat.h>

#define MAX_NAME 255

static char _ini_name[MAX_NAME];

char * __get_ini_name(void)
{
    char *p;

    if ((p = getenv("HOME")) == NULL || strlen(p) > MAX_NAME-20)
	strcpy(_ini_name,"/tmp");
    else 
	strcpy(_ini_name, p);

    strcat(_ini_name,"/.biewrc");

    return _ini_name;
}

char * __get_help_name(void)
{
	return "/usr/lib/biew/biew.hlp";
}

static void cleanup(int sig)
{
	__term_mouse();
	__term_keyboard();
	__term_vio();

	printm("Terminated by signal\n");
	exit(1);
}

void __term_sys(void)
{
/*
     __term_mouse();
    __term_keyboard();
    __term_vio();
*/
}

void __init_sys(void)
{

/*
    __init_vio();
    __init_keyboard();
    __init_mouse();
*/

	umask(0077);
	signal(SIGTERM, cleanup);
	signal(SIGINT, cleanup);
	signal(SIGQUIT, cleanup);
	signal(SIGILL, cleanup);
	signal(SIGSEGV, cleanup);
}

void __OsYield(void)
{
	struct timespec t = { 0, 1000 };
	nanosleep(&t, NULL);

//	if there's no nanosleep:
//
//	usleep(1000);
}
