/****************************************************************************\
*   TIMER - this source file is part of Binary vIEW project (BIEW)           *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   lib/sysdep/i86/dos/timer.c                         *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain implementation of timer depended part for DOS-32.       *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include <go32.h>
#include <dpmi.h>
#include <stddef.h>
#include "__os_dep.h"

static __dpmi_paddr original_timer = { 0, 0 };
static timer_callback *user_callback = NULL;

extern unsigned __djgpp_ds_alias;

static void lib_callback( void )
{
  asm(".byte   0x1E"); /* push ds */
  asm("pushal");
  asm(".byte   0x2E\n" /* cs: prefix */
      "movl    %0, %%eax"::"m"(__djgpp_ds_alias));
  asm(".byte   0x8E, 0xD8"); /* mov ds, ax */
  if(user_callback) (*user_callback)();
  asm("popal");
  asm(".byte   0x1F"); /* pop ds */
}

static void timer_handler( void )
{
  lib_callback();
  asm(".byte    0xCF"); /* iret method */
}

unsigned              __OsSetTimerCallBack(unsigned ms,timer_callback func)
{
   __dpmi_paddr new_timer;
   if(!original_timer.selector)
      __dpmi_get_protected_mode_interrupt_vector(0x1C,&original_timer);
   user_callback = func;
   new_timer.selector = _my_cs();
   new_timer.offset32 = (unsigned)&timer_handler;
   __dpmi_set_protected_mode_interrupt_vector(0x1C, &new_timer);
   return 54;
}

                             /* Restore time callback function to original
                                state */
void                   __OsRestoreTimer(void)
{
  if(original_timer.selector)
   __dpmi_set_protected_mode_interrupt_vector(0x1C, &original_timer);
}
 