/****************************************************************************\
*   MOUSE - this source file is part of Binary vIEW project (BIEW)           *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   lib/sysdep/i386/win32/mouse.c                      *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain implementation of mouse handles for Win32s.             *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include <windows.h>
#include <limits.h>
#include <string.h>
#include "__os_dep.h"

static int ms_visible = 0;
int win32_mx,win32_my;
int win32_mbuttons;

extern void win32_readNextMessage( void );

int __init_mouse( void )
{
  int ret;
  SetConsoleMode(GetStdHandle(STD_INPUT_HANDLE),ENABLE_MOUSE_INPUT);
  if(GetNumberOfConsoleMouseButtons(&ret)== 0) ret = INT_MAX;
  return ret; /* return number of mouse button */
}

void __term_mouse( void )
{
  int cmode;
  GetConsoleMode(GetStdHandle(STD_INPUT_HANDLE),&cmode);
  cmode &= ~ENABLE_MOUSE_INPUT;
  SetConsoleMode(GetStdHandle(STD_INPUT_HANDLE),ENABLE_MOUSE_INPUT);
}

int __MsGetState( void )
{
  return ms_visible;
}

void __MsSetState( int state )
{
  state ? ms_visible++ : ms_visible--;
}

void __MsGetPos( unsigned *mx, unsigned *my )
{
  win32_readNextMessage();
  *mx = win32_mx;
  *my = win32_my;
}

int __MsGetBtns( void )
{
  int ret;
  ret = 0;
  win32_readNextMessage();
  if(win32_mbuttons & FROM_LEFT_1ST_BUTTON_PRESSED) ret |= MS_LEFTPRESS;
  if(win32_mbuttons & RIGHTMOST_BUTTON_PRESSED) ret |= MS_RIGHTPRESS;
  if(win32_mbuttons & FROM_LEFT_2ND_BUTTON_PRESSED & 
     !(win32_mbuttons & RIGHTMOST_BUTTON_PRESSED)) ret |= MS_MIDDLEPRESS;
  return ret;
}

