/****************************************************************************\
*   TIMER - this source file is part of Binary vIEW project (BIEW)           *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   lib/sysdep/i86/dos/timer.c                         *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain implementation of timer depended part for DOS.          *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include <dos.h>
#include <stddef.h>
#include "__os_dep.h"

static void * original_timer = NULL;
static timer_callback *user_callback = NULL;

static void interrupt lib_callback( void )
{
  if(user_callback) (*user_callback)();
}

unsigned              __OsSetTimerCallBack(unsigned ms,timer_callback func)
{
   if(!original_timer)
      original_timer = (void *)getvect(0x1C);
   user_callback = func;
   setvect(0x1C,lib_callback);
   return ms = 54;
}
                             /* Restore time callback function to original
                                state */
void                   __OsRestoreTimer(void)
{
  if(original_timer) setvect(0x1C,(void (interrupt *)())original_timer);
}

