/****************************************************************************\
*   OS_DEP - this source file is part of Binary vIEW project (BIEW)          *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   lib/sysdep/i86/os2/os_dep.c                        *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain implementation of OS depended part for OS/2.            *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#define INCL_SUB
#define INCL_DOSSEMAPHORES
#define INCL_DOSSIGNALS
#define INCL_DOSPROCESS
#define INCL_DOSMODULEMGR
#define INCL_DOSINFOSEG
#define INCL_DOSERRORS
#include <os2.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

HSYSSEM biewSem = 0;

static VOID PASCAL FAR dummy( USHORT sigNum, USHORT sigArg) { }

void __init_sys( void )
{
  USHORT rc;
  rc = DosCreateSem(CSEM_PUBLIC,&biewSem,(PSZ)"\\SEM\\BIEW.SEM");
  if(rc == ERROR_ALREADY_EXISTS) /* means still one copy of biew already runing */
  {
     rc = DosOpenSem(&biewSem,(PSZ)"\\SEM\\BIEW.SEM");
     if(rc)
     {
       fprintf(stderr,"Can not create semaphore: error = %u\n",rc);
       exit(EXIT_FAILURE);
     }
  }
  DosSetSigHandler(&dummy,NULL,NULL,SIGA_ACCEPT,SIG_CTRLBREAK);
}

void __term_sys( void )
{
  DosCloseSem(biewSem);
  DosSetSigHandler(NULL,NULL,NULL,SIGA_KILL,SIG_CTRLBREAK);
}

void __OsYield( void ) { DosSleep(1); }

static char rbuff[256];
extern char **ArgVector;

void getStartupFolder(char *to,unsigned size)
{
   SEL gsel;
   SEL lsel;
   PLINFOSEG plis;
   DosGetInfoSeg((PSEL)&gsel,(PSEL)&lsel);
   plis = MAKEPLINFOSEG(lsel);
   DosGetModName(plis->hmod,size,to);
}

char * __get_ini_name( void )
{
   int len;
   getStartupFolder(rbuff,sizeof(rbuff));
   len = strlen(rbuff);
   if(stricmp(&rbuff[len-4],".exe") == 0) strcpy(&rbuff[len-4],".ini");
   else                                   strcat(rbuff,".ini");
   return rbuff;
}

static char rbuff2[256];
char * __get_help_name( void )
{
   int len;
   getStartupFolder(rbuff2,sizeof(rbuff2));
   len = strlen(rbuff2);
   if(stricmp(&rbuff2[len-4],".exe") == 0) strcpy(&rbuff2[len-4],".hlp");
   else                                    strcat(rbuff2,".hlp");
   return rbuff2;
}
 