/****************************************************************************\
*   TIMER - this source file is part of Binary vIEW project (BIEW)           *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   lib/sysdep/i86/os2/timer.c                         *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain implementation of timer depended part for OS/2.         *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#define INCL_DOSSEMAPHORES
#define INCL_DOSINFOSEG
#define INCL_DOSDATETIME
#define INCL_DOSPROCESS
#include <os2.h>
#include <stddef.h>
#include <stdlib.h>
#include "__os_dep.h"

extern HSYSSEM biewSem;
static HTIMER  timerID = 0;
static TID     timerThread = 0;
static         timer_callback *user_callback = NULL;
static BYTE *thread_stack = 0;

static void thread_callback( void )
{
  while(1)
  {
    DosSemSetWait(biewSem,SEM_INDEFINITE_WAIT);
    if(user_callback) (*user_callback)();
    else DosExit(EXIT_THREAD,0);
  }
}

unsigned              __OsSetTimerCallBack(unsigned ms,timer_callback func)
{
   SEL gsel;
   SEL lsel;
   PGINFOSEG pgis;
   int rc;
   USHORT real_interval;
   if(!(thread_stack = malloc(0x1000))) return 0;
   DosGetInfoSeg((PSEL)&gsel,(PSEL)&lsel);
   pgis = MAKEPGINFOSEG(gsel);
   real_interval = pgis->cusecTimerInterval;
   user_callback = func;
   rc = DosCreateThread(&thread_callback,&timerThread,thread_stack + 0xFFC);
   if(!rc) rc = DosSetPrty(PRTYS_THREAD,PRTYC_TIMECRITICAL,PRTYD_MINIMUM,timerThread);
   if(!rc)
   {
       if(DosTimerStart(real_interval-1,biewSem,&timerID) == 0)
       {
          return real_interval;
       }
   }
   if(thread_stack) { free(thread_stack); thread_stack = 0; }
   return 0;
}
                             /* Restore time callback function to original
                                state */
void                   __OsRestoreTimer(void)
{
  RESULTCODES rcs;
  PID pid;
  if(timerID) { DosTimerStop(timerID); timerID = 0; }
  user_callback = 0;
  DosCwait(DCWA_PROCESS,DCWW_WAIT,&rcs,&pid,timerThread);
  if(thread_stack)
  {
    free(thread_stack);
    thread_stack = 0;
  }
}

 