/****************************************************************************\
*   ARCH - this source file is part of Binary vIEW project (BIEW)            *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   plugins/bin/arch.c                                 *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain implementation of Archive file format decoder.          *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include "pmalloc.h"
#include "lib/sysdep/_sys_dep.h"
#include "bmfile.h"
#include "bin_util.h"
#include "biewhelp.h"
#include "kbd_code.h"
#include "bconsole.h"
#include "biewutil.h"
#include "reg_form.h"
#include "tstrings.h"
#include "plugins/bin/arch.h"

ar_hdr arch;

unsigned long ShowARCHHeader( void )
{
  unsigned long fpos;
  TWindow * w;
  char sout[50];
  fpos = BMGetCurrFilePos();
  w = CrtHlpWnd(" This is COFF or a.out archive ",54,6);
  twGotoXY(1,1);
  strncpy(sout,arch.ar_name,16);
  sout[16] = 0;
  twPrintF("Name           = %s\n",sout);
  strncpy(sout,arch.ar_date,12);
  sout[12] = 0;
  twPrintF("Date           = %s\n",sout);
  strncpy(sout,arch.ar_uid,6);
  sout[6] = 0;
  twPrintF("Owner UID      = %s\n",sout);
  strncpy(sout,arch.ar_gid,6);
  sout[6] = 0;
  twPrintF("Owner GID      = %s\n",sout);
  strncpy(sout,arch.ar_mode,8);
  sout[8] = 0;
  twPrintF("File mode      = %s\n",sout);
  strncpy(sout,arch.ar_size,10);
  sout[10] = 0;
  twPrintF("File size      = %s",sout);
  while(GetEvent(drawEmptyPrompt,w) != KE_ESCAPE);
  CloseWnd(w);
  return fpos;
}

static int __NEAR__ archReadModList(memArray *obj,unsigned nnames,unsigned long *addr)
{
  unsigned long foff;
  unsigned i;
  char stmp[80];
  for(i = 0;i < nnames;i++)
  {
    foff = BYTE_SWAP_L(addr[i]);
    if(IsKbdTerminate()) break;
    BMReadBufferEx(stmp,sizeof(ar_sub_hdr),foff,BM_SEEK_SET);
    stmp[sizeof(ar_sub_hdr)-2] = 0;
    if(!ma_AddString(obj,stmp,1)) break;
  }
  return 1;
}

unsigned long archModLst( void )
{
   memArray *obj;
   unsigned long *addr;
   unsigned nnames;
   unsigned long fpos;
   fpos = BMGetCurrFilePos();
   if(!(nnames = (unsigned)BYTE_SWAP_L(BMReadDWordEx(sizeof(ar_hdr),BM_SEEK_SET)))) { NotifyBox(NOT_ENTRY,"Archive modules list"); return fpos; }
   if(!(obj = ma_Build(nnames,1))) return fpos;
   if(!(addr = PMalloc(sizeof(char *)*nnames))) goto exit;
   BMReadBufferEx(addr,sizeof(char *)*nnames,sizeof(ar_hdr)+sizeof(long),BM_SEEK_SET);
   if(archReadModList(obj,nnames,addr))
   {
     unsigned ret;
     ret = ma_Display(obj," Archive modules list ",LB_SELECTIVE,-1);
     if(ret != -1)
     {
       fpos = BYTE_SWAP_L(addr[ret]) + sizeof(ar_sub_hdr);
     }
   }
   free(addr);
   exit:
   ma_Destroy(obj);
   BMSeek(fpos,BM_SEEK_SET);
   return fpos;
}

int IsArch( void )
{
  char str[16];
  BMReadBufferEx(str,sizeof(str),0,BM_SEEK_SET);
  return strncmp(str,"!<arch>\012",8) == 0;
}

void ArchInit( void )
{
  BMReadBufferEx(&arch,sizeof(arch),0,BM_SEEK_SET);
}

void ArchDestroy( void )
{
}

void archAddrResolv(char *addr,unsigned long cfpos)
{
  if(cfpos < sizeof(ar_hdr))
  {
    sprintf(addr,"arch.h:%s",Get2Digit(cfpos));
  }
}

unsigned long archHelp( void )
{
  hlpDisplay(10001);
  return BMGetCurrFilePos();
}

REGISTRY_BIN archTable =
{
  "arch",
  { "ArcHlp", NULL, "ModLst", NULL, NULL, NULL, NULL, NULL, NULL, NULL },
  { archHelp, NULL, archModLst, NULL, NULL, NULL, NULL, NULL, NULL, NULL },
  IsArch, ArchInit, ArchDestroy,
  ShowARCHHeader,
  NULL,
  NULL,
  NULL,
  archAddrResolv,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL
};
  