/****************************************************************************\
*   ARCH - this header file is part of Binary vIEW project (BIEW)            *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   plugins/bin/arch.h                                 *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain Archive file definitions                                *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#ifndef __ARCH_INC
#define __ARCH_INC

#include "biewtype.h"

#ifdef __GNUC__
#pragma pack(1)
#endif


/* Note that the usual '\n' in magic strings may translate to different
   tByteacters, as allowed by ANSI.  '\012' has a fixed value, and remains
   compatible with existing BSDish archives. */

#define ARMAG  "!<arch>\012"	/* For COFF and a.out archives */
#define ARMAGB "!<bout>\012"	/* For b.out archives */
#define SARMAG 8
#define ARFMAG "`\012"

/* The ar_date field of the armap (__.SYMDEF) member of an archive
   must be greater than the modified date of the entire file, or
   BSD-derived linkers complain.  We originally write the ar_date with
   this offset from the real file's mod-time.  After finishing the
   file, we rewrite ar_date if it's not still greater than the mod date.  */

#define ARMAP_TIME_OFFSET       60

typedef struct tag_ar_hdr {
  char  ar_magic[8];             /* !<arch>012 */
  char  ar_name[16];		/* name of this member */
  char  ar_date[12];		/* file mtime */
  tByte ar_uid[6];		/* owner uid; printed as decimal */
  tByte ar_gid[6];		/* owner gid; printed as decimal */
  tByte ar_mode[8];		/* file mode, printed as octal   */
  tByte ar_size[10];		/* file size, printed as decimal */
  tByte ar_fmag[2];		/* should contain ARFMAG */
}ar_hdr;

typedef struct tag_ar_sub_hdr {
  char  ar_name[16];		/* name of this member */
  char  ar_date[12];		/* file mtime */
  tByte ar_uid[6];		/* owner uid; printed as decimal */
  tByte ar_gid[6];		/* owner gid; printed as decimal */
  tByte ar_mode[8];		/* file mode, printed as octal   */
  tByte ar_size[10];		/* file size, printed as decimal */
  tByte ar_fmag[2];		/* should contain ARFMAG */
}ar_sub_hdr;

#ifdef __GNUC__
#pragma pack()
#endif

#endif 