/****************************************************************************\
*   NE - this header file is part of Binary vIEW project (BIEW)              *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   plugins/bin/ne.h                                   *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain NE executable file definitions                          *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#ifndef __NE_INC
#define __NE_INC

#include "biewtype.h"

#ifdef __GNUC__
#pragma pack(1)
#endif

#define NE_WIN2X_ON_3X_PROTMODE 2
#define NE_WIN2X_PROPORTFONT    4
#define NE_FASTLOADAREA         8

typedef struct tagNEHEADER  // New EXE header
{
 tByte  neSignature[2];               // 'NE'
 tByte  neLinkerVersion;
 tByte  neLinkerRevision;
 tWord  neOffsetEntryTable;
 tWord  neLengthEntryTable;
 tDWord neChecksum;
 tWord  neContestEXE;
 tWord  neAutoDataSegmentCount;
 tWord  neHeapSize;
 tWord  neStackSize;
 tDWord neCSIPvalue;
 tDWord neSSSPvalue;
 tWord  neSegmentTableCount;
 tWord  neModuleReferenceTableCount;
 tWord  neLengthNonResidentNameTable;
 tWord  neOffsetSegmentTable;
 tWord  neOffsetResourceTable;
 tWord  neOffsetResidentNameTable;
 tWord  neOffsetModuleReferenceTable;
 tWord  neOffsetImportTable;
 tDWord neOffsetNonResidentNameTable;
 tWord  neMoveableEntryPointCount;
 tWord  neLogicalSectorShiftCount;
 tWord  neResourceSegmentCount;
 tByte  neOperatingSystem;
 tByte  neFlagsOther;
 // os depended 64 bytes struct
 tWord  neOffsetFastLoadArea;
 tWord  neLengthFastLoadArea;
 tWord  neReserved;
 tWord  neWindowsVersion;

}NEHEADER;

typedef struct tagSEGDEF
{
  tWord sdOffset;
  tWord sdLength;
  tWord sdFlags;
  tWord sdMinMemory;
}SEGDEF;

extern int ReadSegDef(SEGDEF *,tWord numseg);

typedef struct tagENTRY
{
 tByte eFlags;
 tByte eFixed; // 1 - fixed 0 - moveable
 // tWord eInt3F;
 tByte eSegNum;
 tWord eSegOff;
}ENTRY;

typedef struct tagNAMEINFO
{
  tWord rnOffset;
  tWord rnLength;
  tWord rnFlags;
  tWord rnID;
  tWord rnHandle;
  tWord rnUsage;
} NAMEINFO;

extern int ReadEntry(ENTRY *,tWord entnum);

typedef struct tagRELOC_NE
{
  tByte AddrType;
  tByte Type;
  tWord RefOff;
  tWord idx;
  tWord ordinal;
}RELOC_NE;

#ifdef __GNUC__
#pragma pack()
#endif

#endif 