/****************************************************************************\
*   RDOFF2 - this source file is part of Binary vIEW project (BIEW)          *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   plugins/bin/rdoff2.c                               *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain implementation of decoder for RDOFF v2 file format      *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include <stddef.h>
#include <string.h>

#include "plugins/bin/rdoff2.h"
#include "reg_form.h"
#include "bin_util.h"
#include "bmfile.h"
#include "kbd_code.h"
#include "bconsole.h"
#include "biewhelp.h"

unsigned long rdoff2_ShowHeader( void )
{
  int endian;
  unsigned long fpos;
  unsigned long hs_len,im_len;
  TWindow *w;
  fpos = BMGetCurrFilePos();
  endian = BMReadByteEx(5,BM_SEEK_SET);
  im_len = BMReadDWord();
  hs_len = BMReadDWord();
  w = CrtHlpWnd(endian == 0x02 ? " RDOFFv2 big endian " : " RDOFFv2 little endian ",54,5);
  twGotoXY(1,1);
  twPrintF("Image length                = %08lXH\n"
           "Header length               = %08lXH\n"
           ,im_len
           ,hs_len);
  while(1)
  {
    int keycode;
    keycode = GetEvent(drawEmptyPrompt,w);
    switch(keycode)
    {
//      case KE_ENTER:      fpos = cs_start; goto exit;
//      case KE_CTL_ENTER:  fpos = ds_start; goto exit;
      case KE_ESCAPE:     goto exit;
      default:            break;
    };
  }
  exit:
  CloseWnd(w);
  BMSeek(fpos,BM_SEEK_SET);
  return fpos;
}


unsigned long rdoff2_Help( void )
{
  hlpDisplay(10012);
  return BMGetCurrFilePos();
}

int rdoff2_check_fmt( void )
{
  char rbuff[6];
  BMReadBufferEx(rbuff,sizeof(rbuff),0L,BM_SEEK_SET);
  return memcmp(rbuff,"RDOFF2",sizeof(rbuff)) == 0 ||
         memcmp(rbuff,"RDOFF\x02",sizeof(rbuff) == 0);
}

void rdoff2_init_fmt( void ) {}
void rdoff2_destroy_fmt() {}

REGISTRY_BIN rdoff2Table =
{
  "RDOFF v2 (Relocatable Dynamic Object File Format)",
  { "RdHelp", NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL },
  { rdoff2_Help, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL },
  rdoff2_check_fmt,
  rdoff2_init_fmt,
  rdoff2_destroy_fmt,
  rdoff2_ShowHeader,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL,
  NULL
};
  