/****************************************************************************\
*   SETUP - this source file is part of Binary vIEW project (BIEW)           *
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++*
*   Copyrights:           1995, 2000 Nick Kurshev                            *
*   License:              See below                                          *
*   Author and developer: Nick Kurshev                                       *
*   Requirement:          ANSI C compatible development system               *
*   Original file name:   setup.c                                            *
*---------------------- [ D e s c r i p t i o n ] ---------------------------*
*  This file contain BIEW setup.                                             *
*-------------------------- [ L i c e n c e ] -------------------------------*
* The Binary vIEW (BIEW) is copyright (C) 1995 Nick Kurshev.                 *
* All rights reserved. This software is redistributable under the licence    *
* given in the file "Licence.en" ("Licence.ru" in russian translation)       *
* distributed in the BIEW archive.                                           *
\****************************************************************************/
#include <string.h>

#include "__os_dep.h"
#include "_sys_dep.h"
#include "setup.h"
#include "twin.h"
#include "bconsole.h"
#include "biewutil.h"
#include "kbd_code.h"

extern char biew_help_name[];

extern unsigned long biew_vioIniFlags;

char * biewGetHelpName( void )
{
  return biew_help_name[0] ? biew_help_name : __get_help_name();
}

static void __NEAR__ setup_paint( TWindow *twin )
{
  Color bkgnd;
  TWindow *usd;
  usd = twUsedWin();
  twUseWin(twin);
  bkgnd = twTextBkGnd(Cyan);
  twGotoXY(2,4);
  twPrintF(" [%c] - Direct console access "
           ,GetBool((biew_vioIniFlags & __TVIO_FLG_DIRECT_CONSOLE_ACCESS) == __TVIO_FLG_DIRECT_CONSOLE_ACCESS));
  twTextBkGnd(bkgnd);
  twUseWin(usd);
}

void Setup(void)
{
  int X1,Y1,X2,Y2;
  int ret;
  TWindow * wdlg,*ewnd;
  char estr[81];
  wdlg = CrtHlpWnd(" Setup ",78,4);
  twGetWinPos(wdlg,&X1,&Y1,&X2,&Y2);
  twSetFooter(wdlg," [F2] - term mode ",TMODE_CENTER,Black,LightGray);
  X1 += 2;
  X2 -= 2;
  Y1 += 2;
  Y2 = Y1;
  ewnd = WindowOpen(X1,Y1,X2,Y2,TWS_VISIBLE | TWS_CURSORABLE | TWS_NLS866);
  twSetColor(White,Cyan);
  twUseWin(wdlg);
  twGotoXY(2,1); twPutS("Input fully qualified help name:");
  twShowWin(ewnd);
  twUseWin(ewnd);
  strcpy(estr,biewGetHelpName());
  setup_paint(wdlg);
  while(1)
  {
   ret = xeditstring(estr,NULL,sizeof(estr));
   switch(ret)
   {
     case KE_ESCAPE: ret = 0; goto exit;
     case KE_ENTER: ret = 1; goto exit;
     case KE_F(2):  biew_vioIniFlags = biew_vioIniFlags & __TVIO_FLG_DIRECT_CONSOLE_ACCESS ?
                                       biew_vioIniFlags & ~__TVIO_FLG_DIRECT_CONSOLE_ACCESS:
                                       biew_vioIniFlags | __TVIO_FLG_DIRECT_CONSOLE_ACCESS;
                    break;
     default: continue;
   }
   setup_paint(wdlg);
  }
  exit:
  if(ret)
  {
    strcpy(biew_help_name,estr);
  }
  CloseWnd(ewnd);
  CloseWnd(wdlg);
}

 